// request.js

import { extend } from "umi-request";

const errmsgMap = {
    
}

interface Config {
  url:string
  method:string
  params?:any
}

const HttpRequest = ({url, method, params}: Config) => {
    let config = {
        method, // 请求方式
        params: (method == 'GET' || method == 'get') ? params : {}, // 如果是get请求使用 params
        data: (method == 'POST' || method == 'post') ? params : '', // 如果是post请求使用 data
        timeout: 5000,
        headers: {
            'Content-Type': 'application/json; charset=utf-8',
            "Accept":"*/*"
        },
        prefix: '',
        suffix: '',
        errorHandler: (error:any) => {
            if (error.response) {
              console.log('error.response',error)
            } else {
              console.log('error.message',error.message)
            }
            throw error;
        },
    }
    const request = extend({...config, responseType:'json'})

    request.interceptors.request.use((request,options) =>{
      return {url, options: { ...options, interceptors: true, }}
    })
    
    request.interceptors.response.use( (response)=>{
      console.log('response ==>', response.clone().json())
      // const data = await response.clone().body && response.clone().body().arrayBuffer()
      // console.log('data ===>',data)
      return response.clone()
    })
    
    return request(url)
}

export default HttpRequest;
